import processing.core.PApplet;
import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

public class GameLoop {
    int activePlayer = 0;

    Tracker tracker;

    GraphicsProgram graphics;

    GameLogic gl;

    Player player1;
    Player player2;

    public GameLoop(){
        player1 = new Player(0, "ip", 9000);
        player2 = new Player(1, "ip", 9000);
        tracker = new Tracker();
        graphics = new GraphicsProgram();
        String[] args = {"GraphicsProgram"};
        PApplet.runSketch(args, graphics);
        gl = new GameLogic();
        run();
    }

    private void run(){
        while(true){
            communicate();

            List<Point> positions = track();

            addPositions(positions);

            if(gl.doCheck(player2.getTrail(), positions.get(0))){ //Check Position von P1 mit Spur von P2
                System.out.println("Spieler 1 hat verloren");
                break;
            }

            if(gl.doCheck(player1.getTrail(), positions.get(1))){ //Check Position von P2 mit Spur von P1
                System.out.println("Spieler 2 hat verloren");
                break;
            }

            draw();
        }
    }

    private void communicate() {
        //offen für Auto Kommunikation
    }

    private List<Point> track(){
        Point p1 = tracker.getP1();
        Point p2 = tracker.getP2();

        player1.setKoords(p1.x, p1.y);
        player2.setKoords(p2.x, p2.y);

        List<Point> output = new ArrayList<>();
        output.set(0, p1);
        output.set(1, p2);
        return output;
    }

    private void draw(){
        graphics.drawTrail(player1.getTrail(), 0);
        graphics.drawTrail(player2.getTrail(), 1);

    }
}
